--- old/usr/src/uts/common/fs/zfs/spa.c	Mon Aug  5 17:26:53 2019
+++ new/usr/src/uts/common/fs/zfs/spa.c	Mon Aug  5 17:26:53 2019
@@ -21,15 +21,14 @@
 
 /*
  * Copyright (c) 2005, 2010, Oracle and/or its affiliates. All rights reserved.
- * Copyright (c) 2011, 2018 by Delphix. All rights reserved.
- * Copyright (c) 2015, Nexenta Systems, Inc.  All rights reserved.
+ * Copyright (c) 2011, 2017 by Delphix. All rights reserved.
  * Copyright (c) 2014 Spectra Logic Corporation, All rights reserved.
+ * Copyright 2018 Nexenta Systems, Inc.  All rights reserved.
  * Copyright 2013 Saso Kiselkov. All rights reserved.
  * Copyright (c) 2014 Integros [integros.com]
  * Copyright 2016 Toomas Soome <tsoome@me.com>
- * Copyright 2017 Joyent, Inc.
+ * Copyright 2018 Joyent, Inc.
  * Copyright (c) 2017 Datto Inc.
- * Copyright 2018 OmniOS Community Edition (OmniOSce) Association.
  */
 
 /*
@@ -51,15 +50,11 @@
 #include <sys/zil.h>
 #include <sys/ddt.h>
 #include <sys/vdev_impl.h>
-#include <sys/vdev_removal.h>
-#include <sys/vdev_indirect_mapping.h>
-#include <sys/vdev_indirect_births.h>
 #include <sys/metaslab.h>
 #include <sys/metaslab_impl.h>
 #include <sys/uberblock_impl.h>
 #include <sys/txg.h>
 #include <sys/avl.h>
-#include <sys/bpobj.h>
 #include <sys/dmu_traverse.h>
 #include <sys/dmu_objset.h>
 #include <sys/unique.h>
@@ -77,6 +72,9 @@
 #include <sys/dsl_scan.h>
 #include <sys/zfeature.h>
 #include <sys/dsl_destroy.h>
+#include <sys/cos.h>
+#include <sys/special.h>
+#include <sys/wbc.h>
 #include <sys/abd.h>
 
 #ifdef	_KERNEL
@@ -95,7 +93,7 @@
  * The interval, in seconds, at which failed configuration cache file writes
  * should be retried.
  */
-int zfs_ccw_retry_interval = 300;
+static int zfs_ccw_retry_interval = 300;
 
 typedef enum zti_modes {
 	ZTI_MODE_FIXED,			/* value is # of threads (min 1) */
@@ -148,12 +146,22 @@
 	{ ZTI_ONE,	ZTI_NULL,	ZTI_ONE,	ZTI_NULL }, /* IOCTL */
 };
 
+static sysevent_t *spa_event_create(spa_t *spa, vdev_t *vd, nvlist_t *hist_nvl,
+    const char *name);
+static void spa_event_notify_impl(sysevent_t *ev);
 static void spa_sync_version(void *arg, dmu_tx_t *tx);
 static void spa_sync_props(void *arg, dmu_tx_t *tx);
+static void spa_vdev_sync_props(void *arg, dmu_tx_t *tx);
+static int spa_vdev_prop_set_nosync(vdev_t *, nvlist_t *, boolean_t *);
 static boolean_t spa_has_active_shared_spare(spa_t *spa);
-static int spa_load_impl(spa_t *spa, spa_import_type_t type, char **ereport,
-    boolean_t reloading);
+static int spa_load_impl(spa_t *spa, uint64_t, nvlist_t *config,
+    spa_load_state_t state, spa_import_type_t type, boolean_t mosconfig,
+    char **ereport);
 static void spa_vdev_resilver_done(spa_t *spa);
+static void spa_auto_trim(spa_t *spa, uint64_t txg);
+static void spa_vdev_man_trim_done(spa_t *spa);
+static void spa_vdev_auto_trim_done(spa_t *spa);
+static uint64_t spa_min_trim_rate(spa_t *spa);
 
 uint_t		zio_taskq_batch_pct = 75;	/* 1 thread per cpu in pset */
 id_t		zio_taskq_psrset_bind = PS_NONE;
@@ -164,66 +172,6 @@
 extern int	zfs_sync_pass_deferred_free;
 
 /*
- * Report any spa_load_verify errors found, but do not fail spa_load.
- * This is used by zdb to analyze non-idle pools.
- */
-boolean_t	spa_load_verify_dryrun = B_FALSE;
-
-/*
- * This (illegal) pool name is used when temporarily importing a spa_t in order
- * to get the vdev stats associated with the imported devices.
- */
-#define	TRYIMPORT_NAME	"$import"
-
-/*
- * For debugging purposes: print out vdev tree during pool import.
- */
-boolean_t	spa_load_print_vdev_tree = B_FALSE;
-
-/*
- * A non-zero value for zfs_max_missing_tvds means that we allow importing
- * pools with missing top-level vdevs. This is strictly intended for advanced
- * pool recovery cases since missing data is almost inevitable. Pools with
- * missing devices can only be imported read-only for safety reasons, and their
- * fail-mode will be automatically set to "continue".
- *
- * With 1 missing vdev we should be able to import the pool and mount all
- * datasets. User data that was not modified after the missing device has been
- * added should be recoverable. This means that snapshots created prior to the
- * addition of that device should be completely intact.
- *
- * With 2 missing vdevs, some datasets may fail to mount since there are
- * dataset statistics that are stored as regular metadata. Some data might be
- * recoverable if those vdevs were added recently.
- *
- * With 3 or more missing vdevs, the pool is severely damaged and MOS entries
- * may be missing entirely. Chances of data recovery are very low. Note that
- * there are also risks of performing an inadvertent rewind as we might be
- * missing all the vdevs with the latest uberblocks.
- */
-uint64_t	zfs_max_missing_tvds = 0;
-
-/*
- * The parameters below are similar to zfs_max_missing_tvds but are only
- * intended for a preliminary open of the pool with an untrusted config which
- * might be incomplete or out-dated.
- *
- * We are more tolerant for pools opened from a cachefile since we could have
- * an out-dated cachefile where a device removal was not registered.
- * We could have set the limit arbitrarily high but in the case where devices
- * are really missing we would want to return the proper error codes; we chose
- * SPA_DVAS_PER_BP - 1 so that some copies of the MOS would still be available
- * and we get a chance to retrieve the trusted config.
- */
-uint64_t	zfs_max_missing_tvds_cachefile = SPA_DVAS_PER_BP - 1;
-/*
- * In the case where config was assembled by scanning device paths (/dev/dsks
- * by default) we are less tolerant since all the existing devices should have
- * been detected and we want spa_load to return the right error codes.
- */
-uint64_t	zfs_max_missing_tvds_scan = 0;
-
-/*
  * ==========================================================================
  * SPA properties routines
  * ==========================================================================
@@ -259,6 +207,7 @@
 {
 	vdev_t *rvd = spa->spa_root_vdev;
 	dsl_pool_t *pool = spa->spa_dsl_pool;
+	spa_meta_placement_t *mp = &spa->spa_meta_policy;
 	uint64_t size, alloc, cap, version;
 	zprop_source_t src = ZPROP_SRC_NONE;
 	spa_config_dirent_t *dp;
@@ -274,7 +223,28 @@
 		spa_prop_add_list(*nvp, ZPOOL_PROP_ALLOCATED, NULL, alloc, src);
 		spa_prop_add_list(*nvp, ZPOOL_PROP_FREE, NULL,
 		    size - alloc, src);
+		spa_prop_add_list(*nvp, ZPOOL_PROP_ENABLESPECIAL, NULL,
+		    (uint64_t)spa->spa_usesc, src);
+		spa_prop_add_list(*nvp, ZPOOL_PROP_MINWATERMARK, NULL,
+		    spa->spa_minwat, src);
+		spa_prop_add_list(*nvp, ZPOOL_PROP_HIWATERMARK, NULL,
+		    spa->spa_hiwat, src);
+		spa_prop_add_list(*nvp, ZPOOL_PROP_LOWATERMARK, NULL,
+		    spa->spa_lowat, src);
+		spa_prop_add_list(*nvp, ZPOOL_PROP_DEDUPMETA_DITTO, NULL,
+		    spa->spa_ddt_meta_copies, src);
 
+		spa_prop_add_list(*nvp, ZPOOL_PROP_META_PLACEMENT, NULL,
+		    mp->spa_enable_meta_placement_selection, src);
+		spa_prop_add_list(*nvp, ZPOOL_PROP_SYNC_TO_SPECIAL, NULL,
+		    mp->spa_sync_to_special, src);
+		spa_prop_add_list(*nvp, ZPOOL_PROP_DDT_META_TO_METADEV, NULL,
+		    mp->spa_ddt_meta_to_special, src);
+		spa_prop_add_list(*nvp, ZPOOL_PROP_ZFS_META_TO_METADEV,
+		    NULL, mp->spa_zfs_meta_to_special, src);
+		spa_prop_add_list(*nvp, ZPOOL_PROP_SMALL_DATA_TO_METADEV, NULL,
+		    mp->spa_small_data_to_special, src);
+
 		spa_prop_add_list(*nvp, ZPOOL_PROP_FRAGMENTATION, NULL,
 		    metaslab_class_fragmentation(mc), src);
 		spa_prop_add_list(*nvp, ZPOOL_PROP_EXPANDSZ, NULL,
@@ -282,12 +252,27 @@
 		spa_prop_add_list(*nvp, ZPOOL_PROP_READONLY, NULL,
 		    (spa_mode(spa) == FREAD), src);
 
+		spa_prop_add_list(*nvp, ZPOOL_PROP_DDT_DESEGREGATION, NULL,
+		    (spa->spa_ddt_class_min == spa->spa_ddt_class_max), src);
+
 		cap = (size == 0) ? 0 : (alloc * 100 / size);
 		spa_prop_add_list(*nvp, ZPOOL_PROP_CAPACITY, NULL, cap, src);
 
+		spa_prop_add_list(*nvp, ZPOOL_PROP_DEDUP_BEST_EFFORT, NULL,
+		    spa->spa_dedup_best_effort, src);
+
+		spa_prop_add_list(*nvp, ZPOOL_PROP_DEDUP_LO_BEST_EFFORT, NULL,
+		    spa->spa_dedup_lo_best_effort, src);
+
+		spa_prop_add_list(*nvp, ZPOOL_PROP_DEDUP_HI_BEST_EFFORT, NULL,
+		    spa->spa_dedup_hi_best_effort, src);
+
 		spa_prop_add_list(*nvp, ZPOOL_PROP_DEDUPRATIO, NULL,
 		    ddt_get_pool_dedup_ratio(spa), src);
 
+		spa_prop_add_list(*nvp, ZPOOL_PROP_DDTCAPPED, NULL,
+		    spa->spa_ddt_capped, src);
+
 		spa_prop_add_list(*nvp, ZPOOL_PROP_HEALTH, NULL,
 		    rvd->vdev_state, src);
 
@@ -306,11 +291,12 @@
 		 */
 		if (pool->dp_free_dir != NULL) {
 			spa_prop_add_list(*nvp, ZPOOL_PROP_FREEING, NULL,
-			    dsl_dir_phys(pool->dp_free_dir)->dd_used_bytes,
+			    dsl_dir_phys(pool->dp_free_dir)->dd_used_bytes +
+			    pool->dp_long_freeing_total,
 			    src);
 		} else {
 			spa_prop_add_list(*nvp, ZPOOL_PROP_FREEING,
-			    NULL, 0, src);
+			    NULL, pool->dp_long_freeing_total, src);
 		}
 
 		if (pool->dp_leak_dir != NULL) {
@@ -390,7 +376,7 @@
 		zprop_source_t src = ZPROP_SRC_DEFAULT;
 		zpool_prop_t prop;
 
-		if ((prop = zpool_name_to_prop(za.za_name)) == ZPOOL_PROP_INVAL)
+		if ((prop = zpool_name_to_prop(za.za_name)) == ZPROP_INVAL)
 			continue;
 
 		switch (za.za_integer_length) {
@@ -469,6 +455,8 @@
 	int error = 0, reset_bootfs = 0;
 	uint64_t objnum = 0;
 	boolean_t has_feature = B_FALSE;
+	uint64_t lowat = spa->spa_lowat, hiwat = spa->spa_hiwat,
+	    minwat = spa->spa_minwat;
 
 	elem = NULL;
 	while ((elem = nvlist_next_nvpair(props, elem)) != NULL) {
@@ -476,9 +464,10 @@
 		char *strval, *slash, *check, *fname;
 		const char *propname = nvpair_name(elem);
 		zpool_prop_t prop = zpool_name_to_prop(propname);
+		spa_feature_t feature;
 
 		switch (prop) {
-		case ZPOOL_PROP_INVAL:
+		case ZPROP_INVAL:
 			if (!zpool_prop_feature(propname)) {
 				error = SET_ERROR(EINVAL);
 				break;
@@ -503,11 +492,17 @@
 			}
 
 			fname = strchr(propname, '@') + 1;
-			if (zfeature_lookup_name(fname, NULL) != 0) {
+			if (zfeature_lookup_name(fname, &feature) != 0) {
 				error = SET_ERROR(EINVAL);
 				break;
 			}
 
+			if (feature == SPA_FEATURE_WBC &&
+			    !spa_has_special(spa)) {
+				error = SET_ERROR(ENOTSUP);
+				break;
+			}
+
 			has_feature = B_TRUE;
 			break;
 
@@ -524,11 +519,35 @@
 		case ZPOOL_PROP_AUTOREPLACE:
 		case ZPOOL_PROP_LISTSNAPS:
 		case ZPOOL_PROP_AUTOEXPAND:
+		case ZPOOL_PROP_DEDUP_BEST_EFFORT:
+		case ZPOOL_PROP_DDT_DESEGREGATION:
+		case ZPOOL_PROP_META_PLACEMENT:
+		case ZPOOL_PROP_FORCETRIM:
+		case ZPOOL_PROP_AUTOTRIM:
 			error = nvpair_value_uint64(elem, &intval);
 			if (!error && intval > 1)
 				error = SET_ERROR(EINVAL);
 			break;
 
+		case ZPOOL_PROP_DDT_META_TO_METADEV:
+		case ZPOOL_PROP_ZFS_META_TO_METADEV:
+			error = nvpair_value_uint64(elem, &intval);
+			if (!error && intval > META_PLACEMENT_DUAL)
+				error = SET_ERROR(EINVAL);
+			break;
+
+		case ZPOOL_PROP_SYNC_TO_SPECIAL:
+			error = nvpair_value_uint64(elem, &intval);
+			if (!error && intval > SYNC_TO_SPECIAL_ALWAYS)
+				error = SET_ERROR(EINVAL);
+			break;
+
+		case ZPOOL_PROP_SMALL_DATA_TO_METADEV:
+			error = nvpair_value_uint64(elem, &intval);
+			if (!error && intval > SPA_MAXBLOCKSIZE)
+				error = SET_ERROR(EINVAL);
+			break;
+
 		case ZPOOL_PROP_BOOTFS:
 			/*
 			 * If the pool version is less than SPA_VERSION_BOOTFS,
@@ -586,6 +605,20 @@
 			}
 			break;
 
+		case ZPOOL_PROP_DEDUP_LO_BEST_EFFORT:
+			error = nvpair_value_uint64(elem, &intval);
+			if ((intval < 0) || (intval > 100) ||
+			    (intval >= spa->spa_dedup_hi_best_effort))
+				error = SET_ERROR(EINVAL);
+			break;
+
+		case ZPOOL_PROP_DEDUP_HI_BEST_EFFORT:
+			error = nvpair_value_uint64(elem, &intval);
+			if ((intval < 0) || (intval > 100) ||
+			    (intval <= spa->spa_dedup_lo_best_effort))
+				error = SET_ERROR(EINVAL);
+			break;
+
 		case ZPOOL_PROP_FAILUREMODE:
 			error = nvpair_value_uint64(elem, &intval);
 			if (!error && (intval < ZIO_FAILURE_MODE_WAIT ||
@@ -647,7 +680,7 @@
 				}
 			}
 			if (strlen(strval) > ZPROP_MAX_COMMENT)
-				error = E2BIG;
+				error = SET_ERROR(E2BIG);
 			break;
 
 		case ZPOOL_PROP_DEDUPDITTO:
@@ -659,6 +692,36 @@
 			    intval != 0 && intval < ZIO_DEDUPDITTO_MIN)
 				error = SET_ERROR(EINVAL);
 			break;
+
+		case ZPOOL_PROP_MINWATERMARK:
+			error = nvpair_value_uint64(elem, &intval);
+			if (!error && (intval > 100))
+				error = SET_ERROR(EINVAL);
+			minwat = intval;
+			break;
+		case ZPOOL_PROP_LOWATERMARK:
+			error = nvpair_value_uint64(elem, &intval);
+			if (!error && (intval > 100))
+				error = SET_ERROR(EINVAL);
+			lowat = intval;
+			break;
+		case ZPOOL_PROP_HIWATERMARK:
+			error = nvpair_value_uint64(elem, &intval);
+			if (!error && (intval > 100))
+				error = SET_ERROR(EINVAL);
+			hiwat = intval;
+			break;
+		case ZPOOL_PROP_DEDUPMETA_DITTO:
+			error = nvpair_value_uint64(elem, &intval);
+			if (!error && (intval > SPA_DVAS_PER_BP))
+				error = SET_ERROR(EINVAL);
+			break;
+		case ZPOOL_PROP_SCRUB_PRIO:
+		case ZPOOL_PROP_RESILVER_PRIO:
+			error = nvpair_value_uint64(elem, &intval);
+			if (error || intval > 100)
+				error = SET_ERROR(EINVAL);
+			break;
 		}
 
 		if (error)
@@ -665,6 +728,14 @@
 			break;
 	}
 
+	/* check if low watermark is less than high watermark */
+	if (lowat != 0 && lowat >= hiwat)
+		error = SET_ERROR(EINVAL);
+
+	/* check if min watermark is less than low watermark */
+	if (minwat != 0 && minwat >= lowat)
+		error = SET_ERROR(EINVAL);
+
 	if (!error && reset_bootfs) {
 		error = nvlist_remove(props,
 		    zpool_prop_to_name(ZPOOL_PROP_BOOTFS), DATA_TYPE_STRING);
@@ -721,7 +792,7 @@
 		    prop == ZPOOL_PROP_READONLY)
 			continue;
 
-		if (prop == ZPOOL_PROP_VERSION || prop == ZPOOL_PROP_INVAL) {
+		if (prop == ZPOOL_PROP_VERSION || prop == ZPROP_INVAL) {
 			uint64_t ver;
 
 			if (prop == ZPOOL_PROP_VERSION) {
@@ -840,7 +911,7 @@
 	    spa_change_guid_sync, &guid, 5, ZFS_SPACE_CHECK_RESERVED);
 
 	if (error == 0) {
-		spa_write_cachefile(spa, B_FALSE, B_TRUE);
+		spa_config_sync(spa, B_FALSE, B_TRUE);
 		spa_event_notify(spa, NULL, NULL, ESC_ZFS_POOL_REGUID);
 	}
 
@@ -1108,6 +1179,7 @@
 
 	spa->spa_normal_class = metaslab_class_create(spa, zfs_metaslab_ops);
 	spa->spa_log_class = metaslab_class_create(spa, zfs_metaslab_ops);
+	spa->spa_special_class = metaslab_class_create(spa, zfs_metaslab_ops);
 
 	/* Try to create a covering process */
 	mutex_enter(&spa->spa_proc_lock);
@@ -1142,9 +1214,6 @@
 		spa_create_zio_taskqs(spa);
 	}
 
-	for (size_t i = 0; i < TXG_SIZE; i++)
-		spa->spa_txg_zio[i] = zio_root(spa, NULL, NULL, 0);
-
 	list_create(&spa->spa_config_dirty_list, sizeof (vdev_t),
 	    offsetof(vdev_t, vdev_config_dirty_node));
 	list_create(&spa->spa_evicting_os_list, sizeof (objset_t),
@@ -1189,12 +1258,6 @@
 		}
 	}
 
-	for (size_t i = 0; i < TXG_SIZE; i++) {
-		ASSERT3P(spa->spa_txg_zio[i], !=, NULL);
-		VERIFY0(zio_wait(spa->spa_txg_zio[i]));
-		spa->spa_txg_zio[i] = NULL;
-	}
-
 	metaslab_class_destroy(spa->spa_normal_class);
 	spa->spa_normal_class = NULL;
 
@@ -1201,6 +1264,9 @@
 	metaslab_class_destroy(spa->spa_log_class);
 	spa->spa_log_class = NULL;
 
+	metaslab_class_destroy(spa->spa_special_class);
+	spa->spa_special_class = NULL;
+
 	/*
 	 * If this was part of an import or the open otherwise failed, we may
 	 * still have errors left in the queues.  Empty them just in case.
@@ -1295,7 +1361,15 @@
 
 	ASSERT(MUTEX_HELD(&spa_namespace_lock));
 
-	spa_load_note(spa, "UNLOADING");
+	/*
+	 * Stop manual trim before stopping spa sync, because manual trim
+	 * needs to execute a synctask (trim timestamp sync) at the end.
+	 */
+	mutex_enter(&spa->spa_auto_trim_lock);
+	mutex_enter(&spa->spa_man_trim_lock);
+	spa_trim_stop_wait(spa);
+	mutex_exit(&spa->spa_man_trim_lock);
+	mutex_exit(&spa->spa_auto_trim_lock);
 
 	/*
 	 * Stop async tasks.
@@ -1333,24 +1407,19 @@
 		spa->spa_async_zio_root = NULL;
 	}
 
-	if (spa->spa_vdev_removal != NULL) {
-		spa_vdev_removal_destroy(spa->spa_vdev_removal);
-		spa->spa_vdev_removal = NULL;
-	}
-
-	if (spa->spa_condense_zthr != NULL) {
-		ASSERT(!zthr_isrunning(spa->spa_condense_zthr));
-		zthr_destroy(spa->spa_condense_zthr);
-		spa->spa_condense_zthr = NULL;
-	}
-
-	spa_condense_fini(spa);
-
 	bpobj_close(&spa->spa_deferred_bpobj);
 
 	spa_config_enter(spa, SCL_ALL, FTAG, RW_WRITER);
 
 	/*
+	 * Stop autotrim tasks.
+	 */
+	mutex_enter(&spa->spa_auto_trim_lock);
+	if (spa->spa_auto_trim_taskq)
+		spa_auto_trim_taskq_destroy(spa);
+	mutex_exit(&spa->spa_auto_trim_lock);
+
+	/*
 	 * Close all vdevs.
 	 */
 	if (spa->spa_root_vdev)
@@ -1403,8 +1472,6 @@
 
 	spa->spa_async_suspended = 0;
 
-	spa->spa_indirect_vdevs_loaded = B_FALSE;
-
 	if (spa->spa_comment != NULL) {
 		spa_strfree(spa->spa_comment);
 		spa->spa_comment = NULL;
@@ -1419,7 +1486,7 @@
  * 'spa_spares.sav_config'.  We parse this into vdevs, try to open them, and
  * then re-generate a more complete list including status information.
  */
-void
+static void
 spa_load_spares(spa_t *spa)
 {
 	nvlist_t **spares;
@@ -1536,7 +1603,7 @@
  * Devices which are already active have their details maintained, and are
  * not re-opened.
  */
-void
+static void
 spa_load_l2cache(spa_t *spa)
 {
 	nvlist_t **l2cache;
@@ -1607,8 +1674,14 @@
 
 			(void) vdev_validate_aux(vd);
 
-			if (!vdev_is_dead(vd))
-				l2arc_add_vdev(spa, vd);
+			if (!vdev_is_dead(vd)) {
+				boolean_t do_rebuild = B_FALSE;
+
+				(void) nvlist_lookup_boolean_value(l2cache[i],
+				    ZPOOL_CONFIG_L2CACHE_PERSISTENT,
+				    &do_rebuild);
+				l2arc_add_vdev(spa, vd, do_rebuild);
+			}
 		}
 	}
 
@@ -1686,27 +1759,6 @@
 }
 
 /*
- * Concrete top-level vdevs that are not missing and are not logs. At every
- * spa_sync we write new uberblocks to at least SPA_SYNC_MIN_VDEVS core tvds.
- */
-static uint64_t
-spa_healthy_core_tvds(spa_t *spa)
-{
-	vdev_t *rvd = spa->spa_root_vdev;
-	uint64_t tvds = 0;
-
-	for (uint64_t i = 0; i < rvd->vdev_children; i++) {
-		vdev_t *vd = rvd->vdev_child[i];
-		if (vd->vdev_islog)
-			continue;
-		if (vdev_is_concrete(vd) && !vdev_is_dead(vd))
-			tvds++;
-	}
-
-	return (tvds);
-}
-
-/*
  * Checks to see if the given vdev could not be opened, in which case we post a
  * sysevent to notify the autoreplace code that the device has been removed.
  */
@@ -1713,24 +1765,55 @@
 static void
 spa_check_removed(vdev_t *vd)
 {
-	for (uint64_t c = 0; c < vd->vdev_children; c++)
+	for (int c = 0; c < vd->vdev_children; c++)
 		spa_check_removed(vd->vdev_child[c]);
 
 	if (vd->vdev_ops->vdev_op_leaf && vdev_is_dead(vd) &&
-	    vdev_is_concrete(vd)) {
+	    !vd->vdev_ishole) {
 		zfs_post_autoreplace(vd->vdev_spa, vd);
 		spa_event_notify(vd->vdev_spa, vd, NULL, ESC_ZFS_VDEV_CHECK);
 	}
 }
 
-static int
-spa_check_for_missing_logs(spa_t *spa)
+static void
+spa_config_valid_zaps(vdev_t *vd, vdev_t *mvd)
 {
-	vdev_t *rvd = spa->spa_root_vdev;
+	ASSERT3U(vd->vdev_children, ==, mvd->vdev_children);
 
+	vd->vdev_top_zap = mvd->vdev_top_zap;
+	vd->vdev_leaf_zap = mvd->vdev_leaf_zap;
+
+	for (uint64_t i = 0; i < vd->vdev_children; i++) {
+		spa_config_valid_zaps(vd->vdev_child[i], mvd->vdev_child[i]);
+	}
+}
+
+/*
+ * Validate the current config against the MOS config
+ */
+static boolean_t
+spa_config_valid(spa_t *spa, nvlist_t *config)
+{
+	vdev_t *mrvd, *rvd = spa->spa_root_vdev;
+	nvlist_t *nv;
+
+	VERIFY(nvlist_lookup_nvlist(config, ZPOOL_CONFIG_VDEV_TREE, &nv) == 0);
+
+	spa_config_enter(spa, SCL_ALL, FTAG, RW_WRITER);
+	VERIFY(spa_config_parse(spa, &mrvd, nv, NULL, 0, VDEV_ALLOC_LOAD) == 0);
+
 	/*
+	 * One of the earliest signs of a stale config is a mismatch
+	 * in the numbers of children vdev's
+	 */
+	if (rvd->vdev_children != mrvd->vdev_children) {
+		vdev_free(mrvd);
+		spa_config_exit(spa, SCL_ALL, FTAG);
+		return (B_FALSE);
+	}
+	/*
 	 * If we're doing a normal import, then build up any additional
-	 * diagnostic information about missing log devices.
+	 * diagnostic information about missing devices in this config.
 	 * We'll pass this up to the user for further processing.
 	 */
 	if (!(spa->spa_import_flags & ZFS_IMPORT_MISSING_LOG)) {
@@ -1741,52 +1824,106 @@
 		    KM_SLEEP);
 		VERIFY(nvlist_alloc(&nv, NV_UNIQUE_NAME, KM_SLEEP) == 0);
 
-		for (uint64_t c = 0; c < rvd->vdev_children; c++) {
+		for (int c = 0; c < rvd->vdev_children; c++) {
 			vdev_t *tvd = rvd->vdev_child[c];
+			vdev_t *mtvd  = mrvd->vdev_child[c];
 
-			/*
-			 * We consider a device as missing only if it failed
-			 * to open (i.e. offline or faulted is not considered
-			 * as missing).
-			 */
-			if (tvd->vdev_islog &&
-			    tvd->vdev_state == VDEV_STATE_CANT_OPEN) {
-				child[idx++] = vdev_config_generate(spa, tvd,
-				    B_FALSE, VDEV_CONFIG_MISSING);
-			}
+			if (tvd->vdev_ops == &vdev_missing_ops &&
+			    mtvd->vdev_ops != &vdev_missing_ops &&
+			    mtvd->vdev_islog)
+				child[idx++] = vdev_config_generate(spa, mtvd,
+				    B_FALSE, 0);
 		}
 
-		if (idx > 0) {
-			fnvlist_add_nvlist_array(nv,
-			    ZPOOL_CONFIG_CHILDREN, child, idx);
-			fnvlist_add_nvlist(spa->spa_load_info,
-			    ZPOOL_CONFIG_MISSING_DEVICES, nv);
+		if (idx) {
+			VERIFY(nvlist_add_nvlist_array(nv,
+			    ZPOOL_CONFIG_CHILDREN, child, idx) == 0);
+			VERIFY(nvlist_add_nvlist(spa->spa_load_info,
+			    ZPOOL_CONFIG_MISSING_DEVICES, nv) == 0);
 
-			for (uint64_t i = 0; i < idx; i++)
+			for (int i = 0; i < idx; i++)
 				nvlist_free(child[i]);
 		}
 		nvlist_free(nv);
 		kmem_free(child, rvd->vdev_children * sizeof (char **));
+	}
 
-		if (idx > 0) {
-			spa_load_failed(spa, "some log devices are missing");
-			return (SET_ERROR(ENXIO));
-		}
-	} else {
-		for (uint64_t c = 0; c < rvd->vdev_children; c++) {
-			vdev_t *tvd = rvd->vdev_child[c];
+	/*
+	 * Compare the root vdev tree with the information we have
+	 * from the MOS config (mrvd). Check each top-level vdev
+	 * with the corresponding MOS config top-level (mtvd).
+	 */
+	for (int c = 0; c < rvd->vdev_children; c++) {
+		vdev_t *tvd = rvd->vdev_child[c];
+		vdev_t *mtvd  = mrvd->vdev_child[c];
 
-			if (tvd->vdev_islog &&
-			    tvd->vdev_state == VDEV_STATE_CANT_OPEN) {
+		/*
+		 * Resolve any "missing" vdevs in the current configuration.
+		 * If we find that the MOS config has more accurate information
+		 * about the top-level vdev then use that vdev instead.
+		 */
+		if (tvd->vdev_ops == &vdev_missing_ops &&
+		    mtvd->vdev_ops != &vdev_missing_ops) {
+
+			if (!(spa->spa_import_flags & ZFS_IMPORT_MISSING_LOG))
+				continue;
+
+			/*
+			 * Device specific actions.
+			 */
+			if (mtvd->vdev_islog) {
 				spa_set_log_state(spa, SPA_LOG_CLEAR);
-				spa_load_note(spa, "some log devices are "
-				    "missing, ZIL is dropped.");
-				break;
+			} else {
+				/*
+				 * XXX - once we have 'readonly' pool
+				 * support we should be able to handle
+				 * missing data devices by transitioning
+				 * the pool to readonly.
+				 */
+				continue;
 			}
+
+			/*
+			 * Swap the missing vdev with the data we were
+			 * able to obtain from the MOS config.
+			 */
+			vdev_remove_child(rvd, tvd);
+			vdev_remove_child(mrvd, mtvd);
+
+			vdev_add_child(rvd, mtvd);
+			vdev_add_child(mrvd, tvd);
+
+			spa_config_exit(spa, SCL_ALL, FTAG);
+			vdev_load(mtvd);
+			spa_config_enter(spa, SCL_ALL, FTAG, RW_WRITER);
+
+			vdev_reopen(rvd);
+		} else {
+			if (mtvd->vdev_islog) {
+				/*
+				 * Load the slog device's state from the MOS
+				 * config since it's possible that the label
+				 * does not contain the most up-to-date
+				 * information.
+				 */
+				vdev_load_log_state(tvd, mtvd);
+				vdev_reopen(tvd);
+			}
+
+			/*
+			 * Per-vdev ZAP info is stored exclusively in the MOS.
+			 */
+			spa_config_valid_zaps(tvd, mtvd);
 		}
 	}
 
-	return (0);
+	vdev_free(mrvd);
+	spa_config_exit(spa, SCL_ALL, FTAG);
+
+	/*
+	 * Ensure we were able to validate the config.
+	 */
+	return (rvd->vdev_guid_sum == spa->spa_uberblock.ub_guid_sum);
 }
 
 /*
@@ -1852,11 +1989,11 @@
 }
 
 int
-spa_reset_logs(spa_t *spa)
+spa_offline_log(spa_t *spa)
 {
 	int error;
 
-	error = dmu_objset_find(spa_name(spa), zil_reset,
+	error = dmu_objset_find(spa_name(spa), zil_vdev_offline,
 	    NULL, DS_FIND_CHILDREN);
 	if (error == 0) {
 		/*
@@ -1906,8 +2043,7 @@
 
 	abd_free(zio->io_abd);
 	if (error) {
-		if ((BP_GET_LEVEL(bp) != 0 || DMU_OT_IS_METADATA(type)) &&
-		    type != DMU_OT_INTENT_LOG)
+		if (BP_IS_METADATA(bp) && type != DMU_OT_INTENT_LOG)
 			atomic_inc_64(&sle->sle_meta_count);
 		else
 			atomic_inc_64(&sle->sle_data_count);
@@ -1996,16 +2132,10 @@
 	    ZIO_FLAG_CANFAIL | ZIO_FLAG_SPECULATIVE);
 
 	if (spa_load_verify_metadata) {
-		if (spa->spa_extreme_rewind) {
-			spa_load_note(spa, "performing a complete scan of the "
-			    "pool since extreme rewind is on. This may take "
-			    "a very long time.\n  (spa_load_verify_data=%u, "
-			    "spa_load_verify_metadata=%u)",
-			    spa_load_verify_data, spa_load_verify_metadata);
-		}
-		error = traverse_pool(spa, spa->spa_verify_min_txg,
+		zbookmark_phys_t zb = { 0 };
+		error = traverse_pool(spa, spa->spa_verify_min_txg, UINT64_MAX,
 		    TRAVERSE_PRE | TRAVERSE_PREFETCH_METADATA,
-		    spa_load_verify_cb, rio);
+		    spa_load_verify_cb, rio, &zb);
 	}
 
 	(void) zio_wait(rio);
@@ -2013,15 +2143,8 @@
 	spa->spa_load_meta_errors = sle.sle_meta_count;
 	spa->spa_load_data_errors = sle.sle_data_count;
 
-	if (sle.sle_meta_count != 0 || sle.sle_data_count != 0) {
-		spa_load_note(spa, "spa_load_verify found %llu metadata errors "
-		    "and %llu data errors", (u_longlong_t)sle.sle_meta_count,
-		    (u_longlong_t)sle.sle_data_count);
-	}
-
-	if (spa_load_verify_dryrun ||
-	    (!error && sle.sle_meta_count <= policy.zrp_maxmeta &&
-	    sle.sle_data_count <= policy.zrp_maxdata)) {
+	if (!error && sle.sle_meta_count <= policy.zrp_maxmeta &&
+	    sle.sle_data_count <= policy.zrp_maxdata) {
 		int64_t loss = 0;
 
 		verify_ok = B_TRUE;
@@ -2039,9 +2162,6 @@
 		spa->spa_load_max_txg = spa->spa_uberblock.ub_txg;
 	}
 
-	if (spa_load_verify_dryrun)
-		return (0);
-
 	if (error) {
 		if (error != ENXIO && error != EIO)
 			error = SET_ERROR(EIO);
@@ -2065,17 +2185,25 @@
  * Find a value in the pool directory object.
  */
 static int
-spa_dir_prop(spa_t *spa, const char *name, uint64_t *val, boolean_t log_enoent)
+spa_dir_prop(spa_t *spa, const char *name, uint64_t *val)
 {
-	int error = zap_lookup(spa->spa_meta_objset, DMU_POOL_DIRECTORY_OBJECT,
-	    name, sizeof (uint64_t), 1, val);
+	return (zap_lookup(spa->spa_meta_objset, DMU_POOL_DIRECTORY_OBJECT,
+	    name, sizeof (uint64_t), 1, val));
+}
 
-	if (error != 0 && (error != ENOENT || log_enoent)) {
-		spa_load_failed(spa, "couldn't get '%s' value in MOS directory "
-		    "[error=%d]", name, error);
+static void
+spa_set_ddt_classes(spa_t *spa, int desegregation)
+{
+	/*
+	 * if desegregation is turned on then set up ddt_class restrictions
+	 */
+	if (desegregation) {
+		spa->spa_ddt_class_min = DDT_CLASS_DUPLICATE;
+		spa->spa_ddt_class_max = DDT_CLASS_DUPLICATE;
+	} else {
+		spa->spa_ddt_class_min = DDT_CLASS_DITTO;
+		spa->spa_ddt_class_max = DDT_CLASS_UNIQUE;
 	}
-
-	return (error);
 }
 
 static int
@@ -2082,19 +2210,9 @@
 spa_vdev_err(vdev_t *vdev, vdev_aux_t aux, int err)
 {
 	vdev_set_state(vdev, B_TRUE, VDEV_STATE_CANT_OPEN, aux);
-	return (SET_ERROR(err));
+	return (err);
 }
 
-static void
-spa_spawn_aux_threads(spa_t *spa)
-{
-	ASSERT(spa_writeable(spa));
-
-	ASSERT(MUTEX_HELD(&spa_namespace_lock));
-
-	spa_start_indirect_condensing_thread(spa);
-}
-
 /*
  * Fix up config after a partly-completed split.  This is done with the
  * ZPOOL_CONFIG_SPLIT nvlist.  Both the splitting pool and the split-off
@@ -2178,17 +2296,55 @@
 }
 
 static int
-spa_load(spa_t *spa, spa_load_state_t state, spa_import_type_t type)
+spa_load(spa_t *spa, spa_load_state_t state, spa_import_type_t type,
+    boolean_t mosconfig)
 {
+	nvlist_t *config = spa->spa_config;
 	char *ereport = FM_EREPORT_ZFS_POOL;
+	char *comment;
 	int error;
+	uint64_t pool_guid;
+	nvlist_t *nvl;
 
-	spa->spa_load_state = state;
+	if (nvlist_lookup_uint64(config, ZPOOL_CONFIG_POOL_GUID, &pool_guid))
+		return (SET_ERROR(EINVAL));
 
-	gethrestime(&spa->spa_loaded_ts);
-	error = spa_load_impl(spa, type, &ereport, B_FALSE);
+	ASSERT(spa->spa_comment == NULL);
+	if (nvlist_lookup_string(config, ZPOOL_CONFIG_COMMENT, &comment) == 0)
+		spa->spa_comment = spa_strdup(comment);
 
 	/*
+	 * Versioning wasn't explicitly added to the label until later, so if
+	 * it's not present treat it as the initial version.
+	 */
+	if (nvlist_lookup_uint64(config, ZPOOL_CONFIG_VERSION,
+	    &spa->spa_ubsync.ub_version) != 0)
+		spa->spa_ubsync.ub_version = SPA_VERSION_INITIAL;
+
+	(void) nvlist_lookup_uint64(config, ZPOOL_CONFIG_POOL_TXG,
+	    &spa->spa_config_txg);
+
+	if ((state == SPA_LOAD_IMPORT || state == SPA_LOAD_TRYIMPORT) &&
+	    spa_guid_exists(pool_guid, 0)) {
+		error = SET_ERROR(EEXIST);
+	} else {
+		spa->spa_config_guid = pool_guid;
+
+		if (nvlist_lookup_nvlist(config, ZPOOL_CONFIG_SPLIT,
+		    &nvl) == 0) {
+			VERIFY(nvlist_dup(nvl, &spa->spa_config_splitting,
+			    KM_SLEEP) == 0);
+		}
+
+		nvlist_free(spa->spa_load_info);
+		spa->spa_load_info = fnvlist_alloc();
+
+		gethrestime(&spa->spa_loaded_ts);
+		error = spa_load_impl(spa, pool_guid, config, state, type,
+		    mosconfig, &ereport);
+	}
+
+	/*
 	 * Don't count references from objsets that are already closed
 	 * and are making their way through the eviction process.
 	 */
@@ -2205,7 +2361,6 @@
 	}
 	spa->spa_load_state = error ? SPA_LOAD_ERROR : SPA_LOAD_NONE;
 	spa->spa_ena = 0;
-
 	return (error);
 }
 
